/*
 * Created on 2003/10/07
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package jp.sourceforge.jetspeedjapan.portlet.weblog.om.utils;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

/**
 * @author <a href="mailto:shinsuke@users.sourceforge.jp">Shinsuke Sugaya</a>
 */
public class PageList implements List
{
    List list;
    int pageNumber;
    int pageSize;
    boolean next;
    boolean previous;
    int totalSize;

    public PageList(int page, int size)
    {
        this(null, page, size, false, false, 0);
    }

    public PageList(List list, int page, int size, boolean prev, boolean next, int total)
    {
        setList(list);
        setPageNumber(page);
        setPageSize(size);
        setPrevious(prev);
        setNext(next);
        setTotalSize(total);
    }

    /**
     * @return
     */
    public List getList()
    {
        return list;
    }

    /**
     * @return
     */
    public boolean hasNextPage()
    {
        return next;
    }

    /**
     * @return
     */
    public int getPageNumber()
    {
        return pageNumber;
    }

    /**
     * @return
     */
    public boolean hasPreviousPage()
    {
        return previous;
    }

    /**
     * @return
     */
    public int getPageSize()
    {
        return pageSize;
    }

    /**
     * @param list
     */
    public void setList(List list)
    {
        this.list = list;
    }

    /**
     * @param b
     */
    public void setNext(boolean b)
    {
        next = b;
    }

    /**
     * @param i
     */
    public void setPageNumber(int i)
    {
        pageNumber = i;
    }

    /**
     * @param b
     */
    public void setPrevious(boolean b)
    {
        previous = b;
    }

    /**
     * @param i
     */
    public void setPageSize(int i)
    {
        pageSize = i;
    }

    /**
     * @param index
     * @param element
     */
    public void add(int index, Object element)
    {
        list.add(index, element);
    }

    /**
     * @param o
     * @return
     */
    public boolean add(Object o)
    {
        return list.add(o);
    }

    /**
     * @param index
     * @param c
     * @return
     */
    public boolean addAll(int index, Collection c)
    {
        return list.addAll(index, c);
    }

    /**
     * @param c
     * @return
     */
    public boolean addAll(Collection c)
    {
        return list.addAll(c);
    }

    /**
     * 
     */
    public void clear()
    {
        list.clear();
    }

    /**
     * @param o
     * @return
     */
    public boolean contains(Object o)
    {
        return list.contains(o);
    }

    /**
     * @param c
     * @return
     */
    public boolean containsAll(Collection c)
    {
        return list.containsAll(c);
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object obj)
    {
        return list.equals(obj);
    }

    /**
     * @param index
     * @return
     */
    public Object get(int index)
    {
        return list.get(index);
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    public int hashCode()
    {
        return list.hashCode();
    }

    /**
     * @param o
     * @return
     */
    public int indexOf(Object o)
    {
        return list.indexOf(o);
    }

    /**
     * @return
     */
    public boolean isEmpty()
    {
        if(list==null){
            return true;
        }
        return list.isEmpty();
    }

    /**
     * @return
     */
    public Iterator iterator()
    {
        return list.iterator();
    }

    /**
     * @param o
     * @return
     */
    public int lastIndexOf(Object o)
    {
        return list.lastIndexOf(o);
    }

    /**
     * @return
     */
    public ListIterator listIterator()
    {
        return list.listIterator();
    }

    /**
     * @param index
     * @return
     */
    public ListIterator listIterator(int index)
    {
        return list.listIterator(index);
    }

    /**
     * @param index
     * @return
     */
    public Object remove(int index)
    {
        return list.remove(index);
    }

    /**
     * @param o
     * @return
     */
    public boolean remove(Object o)
    {
        return list.remove(o);
    }

    /**
     * @param c
     * @return
     */
    public boolean removeAll(Collection c)
    {
        return list.removeAll(c);
    }

    /**
     * @param c
     * @return
     */
    public boolean retainAll(Collection c)
    {
        return list.retainAll(c);
    }

    /**
     * @param index
     * @param element
     * @return
     */
    public Object set(int index, Object element)
    {
        return list.set(index, element);
    }

    /**
     * @return
     */
    public int size()
    {
        return list.size();
    }

    /**
     * @param fromIndex
     * @param toIndex
     * @return
     */
    public List subList(int fromIndex, int toIndex)
    {
        return list.subList(fromIndex, toIndex);
    }

    /**
     * @return
     */
    public Object[] toArray()
    {
        return list.toArray();
    }

    /**
     * @param a
     * @return
     */
    public Object[] toArray(Object[] a)
    {
        return list.toArray(a);
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString()
    {
        return list.toString();
    }

    /**
     * @return
     */
    public int getTotalSize()
    {
        return totalSize;
    }

    /**
     * @param i
     */
    public void setTotalSize(int i)
    {
        totalSize = i;
    }

}
